## whichman 2.0

=== Makefile ===
# written by Guido Socher
PREFIX=/usr
INSTALL=install
MANP=man1/whichman.1 man1/ftff.1 man1/ftwhich.1
CC=gcc
CFLAGS= -Wall -O2
#sun c/c++-compiler:
#CC=CC
#CFLAGS= -O

all:whichman ftff ftwhich

whichman: whichman.o levdist.o
	$(CC) -o $@ whichman.o levdist.o

ftwhich: ftwhich.o levdist.o
	$(CC) -o $@ ftwhich.o levdist.o

ftff: ftff.o levdist.o 
	$(CC) -o $@ ftff.o levdist.o

whichman.o: whichman.c 
	$(CC) $(CFLAGS) -c whichman.c
ftwhich.o: ftwhich.c 
	$(CC) $(CFLAGS) -c ftwhich.c
ftff.o: ftff.c 
	$(CC) $(CFLAGS) -c ftff.c
levdist.o: levdist.c levdist.h
	$(CC) $(CFLAGS) -c levdist.c

install: whichman ftff ftwhich $(MANP)
	strip whichman
	strip ftwhich
	strip ftff
	[ -d "$(PREFIX)/bin" ] || $(INSTALL) -d $(PREFIX)/bin
	[ -d "$(PREFIX)/man/man1" ] || $(INSTALL) -d $(PREFIX)/man/man1
	$(INSTALL) -m 755 whichman $(PREFIX)/bin
	$(INSTALL) -m 755 ftwhich $(PREFIX)/bin
	$(INSTALL) -m 755 ftff $(PREFIX)/bin
	for p in $(MANP) ; do \
		echo "installing $$p in $(PREFIX)/man/man1"; \
		$(INSTALL) -m 644 $$p $(PREFIX)/man/man1 ;\
	done

install_with_cp: whichman ftff ftwhich $(MANP)
	chmod 755 whichman ftff ftwhich
	[ -d "$(PREFIX)/bin" ] || mkdir -p $(PREFIX)/bin
	cp whichman ftff ftwhich $(PREFIX)/bin
	chmod 644 $(MANP)
	[ -d "$(PREFIX)/man/man1" ] || mkdir -p $(PREFIX)/man/man1
	cp $(MANP) $(PREFIX)/man/man1

debug: levdist.c
	$(CC) $(CFLAGS) -o levdebug -DDEBUG -DRETURNVALUE levdist.c

clean:
	rm -f whichman ftff ftwhich *.o levdebug

## whichman 2.4

=== Makefile ===
# written by Guido Socher
# overwrite with: make prefix=/some/where install
prefix=$(DESTDIR)/usr
INSTALL=install
mandir=$(prefix)/share/man
MANP=man1/whichman.1 man1/ftff.1 man1/ftwhich.1
CC=gcc
CFLAGS= -Wall -O2
#sun c/c++-compiler:
#CC=CC
#CFLAGS= -O

all:whichman ftff ftwhich

whichman: whichman.o levdist.o
	$(CC) -o $@ whichman.o levdist.o

ftwhich: ftwhich.o levdist.o
	$(CC) -o $@ ftwhich.o levdist.o

ftff: ftff.o levdist.o 
	$(CC) -o $@ ftff.o levdist.o

whichman.o: whichman.c 
	$(CC) $(CFLAGS) -c whichman.c
ftwhich.o: ftwhich.c 
	$(CC) $(CFLAGS) -c ftwhich.c
ftff.o: ftff.c 
	$(CC) $(CFLAGS) -c ftff.c
levdist.o: levdist.c levdist.h
	$(CC) $(CFLAGS) -c levdist.c

install: whichman ftff ftwhich $(MANP)
	strip whichman
	strip ftwhich
	strip ftff
	[ -d "$(prefix)/bin" ] || $(INSTALL) -d $(prefix)/bin
	[ -d "$(mandir)/man1" ] || $(INSTALL) -d $(mandir)/man1
	$(INSTALL) -m 755 whichman $(prefix)/bin
	$(INSTALL) -m 755 ftwhich $(prefix)/bin
	$(INSTALL) -m 755 ftff $(prefix)/bin
	for p in $(MANP) ; do \
		echo "installing $$p in $(mandir)/man1"; \
		$(INSTALL) -m 644 $$p $(mandir)/man1 ;\
	done

install_with_cp: whichman ftff ftwhich $(MANP)
	chmod 755 whichman ftff ftwhich
	[ -d "$(prefix)/bin" ] || mkdir -p $(prefix)/bin
	cp whichman ftff ftwhich $(prefix)/bin
	chmod 644 $(MANP)
	[ -d "$(mandir)/man1" ] || mkdir -p $(mandir)/man1
	cp $(MANP) $(mandir)/man1

debug: levdist.c
	$(CC) $(CFLAGS) -o levdebug -DDEBUG -DRETURNVALUE levdist.c

clean:
	rm -f whichman ftff ftwhich *.o levdebug

=== debian/changelog ===
whichman (2.4-9) unstable; urgency=medium

  * Add 12-Fix-gcc8-warnings.patch to fix 'implicit-fallthrough' warnings.
  * Switch to debhelper v11.
  * Enable all hardening options.
  * Switch debian/copyright into DEP-5 format.
  * Update Vcs-* fields for salsa migration.
  * Standards-Version: 4.1.4.

 -- Robert Luberda <robert@debian.org>  Mon, 02 Jul 2018 22:34:30 +0200

whichman (2.4-8) unstable; urgency=medium

  * Add 11-CPPFLAGS-and-LDFLAGS.patch to pass the two variables
    to compiler.
  * Cleanup debian/rules, add support for cross-compiling, and
    enable LFS support.
  * Standards-Version: 3.9.5 (no changes).

 -- Robert Luberda <robert@debian.org>  Sat, 14 Dec 2013 21:35:44 +0100

whichman (2.4-7) unstable; urgency=low

  * Switch to debhelper v9 and tiny rules file.
  * Rename & refresh patches with gbp-pq import/export.
  * Fix lintian's `spelling-error-in-copyright'.
  * debian/rules: remove .pc/.dpkg-source-unapply file in rules.
    This fixes broken behaviour of dpkg-buildpackage (see Bug#649521).
  * debian/control:
    + Standards-Version: 3.9.2 (no changes);
    + add VCS fields;
    + sort dependency fields with wrap-and-sort.

 -- Robert Luberda <robert@debian.org>  Sun, 19 Feb 2012 16:05:46 +0100

whichman (2.4-6) unstable; urgency=low

  * Switch to the `3.0 (quilt)' format.
  * Bump to debhelper v8.
  * Standards-Version: 3.9.1 (no changes).
  * Split the previous 01_debian.patch into 3 patches: 00_Makefile.patch,
    01_documentation.patch, and 02_no_warn.patch.
  * debian/rules:
    + use dpkg-buildflags for getting CFLAGS/LDFLAGS (also added versioned
      build-dependency on dpkg-dev for this);
    + call dh_auto_{configure,build,clean} commands;
    + provide build-{arch,indep} targets.

 -- Robert Luberda <robert@debian.org>  Tue, 15 Feb 2011 22:29:25 +0100

whichman (2.4-5) unstable; urgency=low

  * Add copyright notice (lintian),

 -- Robert Luberda <robert@debian.org>  Sat, 19 Apr 2008 16:04:29 +0200

whichman (2.4-4) unstable; urgency=low

  * Use quilt to manage patches, move old debian patch to 01_debian.patch.
  * Build with debhelper v6.
  * 10_skip_duplicates.patch: Avoid duplicated files from `ftwhich' and
    `whichman' output (closes: #452068).
  * Standards-Version: 3.7.3 (no changes).
  * debian/control: Add Homepage URL.

 -- Robert Luberda <robert@debian.org>  Tue, 29 Jan 2008 22:39:17 +0100

whichman (2.4-3) unstable; urgency=low

  * Fix the `debian-rules-ignores-make-clean-error'.
    and manpage-has-errors-from-man' lintian errors.
  * Bump debhelper compat version to 6.
  * Standards-Version: 3.7.2 (no changes).

 -- Robert Luberda <robert@debian.org>  Mon, 15 Oct 2007 21:37:39 +0200

whichman (2.4-2) unstable; urgency=low

  * Fix typos in ftwhich(1) and ftff(1) man pages.
    (Closes: #306727,#306728).
  * Add debian/watch file.

 -- Robert Luberda <robert@debian.org>  Fri, 29 Apr 2005 19:06:43 +0200

whichman (2.4-1) unstable; urgency=low

  * New upstream version.

 -- Robert Luberda <robert@debian.org>  Tue, 20 Apr 2004 19:48:32 +0200

whichman (2.3-2) unstable; urgency=low

  * Opps, man pages went to /usr/share/man/man1/man1. Fixed.

 -- Robert Luberda <robert@debian.org>  Sun, 28 Mar 2004 23:15:17 +0200

whichman (2.3-1) unstable; urgency=low

  * New upstream version.
  * Standards-Version: 3.6.1 (no changes).

 -- Robert Luberda <robert@debian.org>  Wed, 24 Mar 2004 19:39:44 +0100

whichman (2.2-1) unstable; urgency=low

  * New upstream version.
  * debian/control: remove ending dot from the first line of the description
    field (lintian).
  * debian/copyright: update URLs.
  * Standards-Version: 3.5.8 (no changes).

 -- Robert Luberda <robert@debian.org>  Thu,  9 Jan 2003 00:01:13 +0100

whichman (2.0-3) unstable; urgency=low

  * Upgrade to Standards: 3.5.7
  * Build in debhelper in v4 mode.

 -- Robert Luberda <robert@debian.org>  Tue, 22 Oct 2002 22:20:23 +0200

whichman (2.0-2) unstable; urgency=low

  * Corrected spelling error in description (closes: #125481) and upstream
    README file. Thanks to Matt Ziemmerman.
  * Standards-Version: 3.5.6 (no changes).

 -- Robert Luberda <robert@debian.org>  Sat, 22 Dec 2001 22:22:00 +0100

whichman (2.0-1) unstable; urgency=low

  * New upstream version.
  * Fixed gcc 3.0 warnings.

 -- Robert Luberda <robert@debian.org>  Fri,  6 Jul 2001 22:49:21 +0200

whichman (1.9-2) unstable; urgency=low

  * Some fixes in manpages.
  * Updated debian/rules to the newest debhelper.
  * Standards-Version: 3.5.5.

 -- Robert Luberda <robert@debian.org>  Wed,  4 Jul 2001 22:58:46 +0200

whichman (1.9-1) unstable; urgency=low

  * Initial release (closes: #83624).
  * Use default Debian manpath if environment variable MANPATH
    is not set.

 -- Robert Luberda <robert@debian.org>  Mon, 29 Jan 2001 20:30:47 +0100

=== debian/control ===
Source: whichman
Section: utils
Priority: optional
Maintainer: Robert Luberda <robert@debian.org>
Build-Depends: debhelper (>= 11)
Standards-Version: 4.1.4
Homepage: http://linuxfocus.org/~guido/#whichman
Vcs-Git: https://salsa.debian.org/debian/whichman.git
Vcs-Browser: https://salsa.debian.org/debian/whichman/

Package: whichman
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Fault tolerant search utilities: whichman, ftff, ftwhich
 whichman uses a fault tolerant approximate matching algorithm to search
 for man-pages that match approximately the specified name.
 The fault tolerant matching is very useful in cases where you remember only
 roughly the name of a command.
 .
    Example: whichman netwhat
    This finds netstat.8: /usr/share/man/man8/netstat.8
 .
 ftff searches the directory tree. This is a case in-sensitive and fault
 tolerant way of 'find . -name xxxx -print'.
 .
 ftwhich finds files which are in one of the directories in your PATH
 and uses a fault tolerant search algorithm.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS := hardening=+all
DH_AUTO_OPTIONS := -v -Smakefile --parallel
DESTDIR         := $(CURDIR)/debian/$(shell dh_listpackages)
export CFLAGS   := $(shell dpkg-buildflags --get CFLAGS) $(shell getconf LFS_CFLAGS) -Wall -Wextra

include /usr/share/dpkg/architecture.mk

ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  export CC := $(DEB_HOST_GNU_TYPE)-gcc
else
  export CC := gcc
endif

%:
	dh "$@"

override_dh_auto_build:
	dh_auto_build $(DH_AUTO_OPTIONS) -- \
	                STRIP=: CFLAGS="$(CFLAGS)" CC=$(CC)

override_dh_auto_clean:
	dh_auto_clean $(DH_AUTO_OPTIONS)

override_dh_auto_install:
	dh_auto_install $(DH_AUTO_OPTIONS) --destdir="$(DESTDIR)" -- \
	                STRIP=: CFLAGS="$(CFLAGS)" CC=$(CC)

=== debian/watch ===
version=2
http://linuxfocus.org/~guido/whichman-([\d\.]+)\.tar\.gz
